JUCE: MouseInputSource Class Reference

JUCE

Public Types | Public Member Functions | Static Public Attributes | List of all members
MouseInputSource Class Referencefinal
juce_gui_basics » mouse

Represents a linear source of mouse events from a mouse device or individual finger in a multi-touch environment. More...

`#include <juce_MouseInputSource.h>`

## Public Types
enum | InputSourceType { mouse , touch , pen }
| Possible mouse input sources. More...

## Public Member Functions
| MouseInputSource (const MouseInputSource &) noexcept
MouseInputSource & | operator= (const MouseInputSource &) noexcept
| ~MouseInputSource () noexcept
bool | operator== (const MouseInputSource &other) const noexcept
bool | operator!= (const MouseInputSource &other) const noexcept
MouseInputSource::InputSourceType | getType () const noexcept
| Returns the type of input source that this object represents. More...
bool | isMouse () const noexcept
| Returns true if this object represents a normal desk-based mouse device. More...
bool | isTouch () const noexcept
| Returns true if this object represents a source of touch events. More...
bool | isPen () const noexcept
| Returns true if this object represents a pen device. More...
bool | canHover () const noexcept
| Returns true if this source has an on-screen pointer that can hover over items without clicking them. More...
bool | hasMouseWheel () const noexcept
| Returns true if this source may have a scroll wheel. More...
int | getIndex () const noexcept
| Returns this source's index in the global list of possible sources. More...
bool | isDragging () const noexcept
| Returns true if this device is currently being pressed. More...
Point< float > | getScreenPosition () const noexcept
| Returns the last-known screen position of this source. More...
Point< float > | getRawScreenPosition () const noexcept
| Returns the last-known screen position of this source without any scaling applied. More...
ModifierKeys | getCurrentModifiers () const noexcept
| Returns a set of modifiers that indicate which buttons are currently held down on this device. More...
float | getCurrentPressure () const noexcept
| Returns the device's current touch or pen pressure. More...
float | getCurrentOrientation () const noexcept
| Returns the device's current orientation in radians. More...
float | getCurrentRotation () const noexcept
| Returns the device's current rotation. More...
float | getCurrentTilt (bool tiltX) const noexcept
| Returns the angle of tilt of the pointer in a range of -1.0 to 1.0 either in the x- or y-axis. More...
bool | isPressureValid () const noexcept
| Returns true if the current pressure value is meaningful. More...
bool | isOrientationValid () const noexcept
| Returns true if the current orientation value is meaningful. More...
bool | isRotationValid () const noexcept
| Returns true if the current rotation value is meaningful. More...
bool | isTiltValid (bool tiltX) const noexcept
| Returns true if the current tilt value (either x- or y-axis) is meaningful. More...
Component * | getComponentUnderMouse () const
| Returns the component that was last known to be under this pointer. More...
void | triggerFakeMove () const
| Tells the device to dispatch a mouse-move or mouse-drag event. More...
int | getNumberOfMultipleClicks () const noexcept
| Returns the number of clicks that should be counted as belonging to the current mouse event. More...
Time | getLastMouseDownTime () const noexcept
| Returns the time at which the last mouse-down occurred. More...
Point< float > | getLastMouseDownPosition () const noexcept
| Returns the screen position at which the last mouse-down occurred. More...
bool | isLongPressOrDrag () const noexcept
| Returns true if this input source represents a long-press or drag interaction i.e. More...
bool | hasMovedSignificantlySincePressed () const noexcept
| Returns true if this input source has been dragged more than a couple of pixels from the place it was pressed. More...
bool | hasMouseCursor () const noexcept
| Returns true if this input source uses a visible mouse cursor. More...
void | showMouseCursor (const MouseCursor &cursor)
| Changes the mouse cursor, (if there is one). More...
void | hideCursor ()
| Hides the mouse cursor (if there is one). More...
void | revealCursor ()
| Un-hides the mouse cursor if it was hidden by hideCursor(). More...
void | forceMouseCursorUpdate ()
| Forces an update of the mouse cursor for whatever component it's currently over. More...
bool | canDoUnboundedMovement () const noexcept
| Returns true if this mouse can be moved indefinitely in any direction without running out of space. More...
void | enableUnboundedMouseMovement (bool isEnabled, bool keepCursorVisibleUntilOffscreen=false) const
| Allows the mouse to move beyond the edges of the screen. More...
bool | isUnboundedMouseMovementEnabled () const
| Returns true if this source is currently in "unbounded" mode. More...
void | setScreenPosition (Point< float > newPosition)
| Attempts to set this mouse pointer's screen position. More...

## Static Public Attributes
static constexpr float | defaultPressure = 0.0f
| A default value for pressure, which is used when a device doesn't support it, or for mouse-moves, mouse-ups, etc. More...
static constexpr float | defaultOrientation = 0.0f
| A default value for orientation, which is used when a device doesn't support it. More...
static constexpr float | defaultRotation = 0.0f
| A default value for rotation, which is used when a device doesn't support it. More...
static constexpr float | defaultTiltX = 0.0f
| Default values for tilt, which are used when a device doesn't support it. More...
static constexpr float | defaultTiltY = 0.0f
static const float | invalidPressure
| A default value for pressure, which is used when a device doesn't support it. More...
static const float | invalidOrientation
| A default value for orientation, which is used when a device doesn't support it. More...
static const float | invalidRotation
| A default value for rotation, which is used when a device doesn't support it. More...
static const float | invalidTiltX
| Default values for tilt, which are used when a device doesn't support it. More...
static const float | invalidTiltY
static const Point< float > | offscreenMousePos
| An offscreen mouse position used when triggering mouse exits where we don't want to move the cursor over an existing component. More...

## Detailed Description

Represents a linear source of mouse events from a mouse device or individual finger in a multi-touch environment.

Each MouseEvent object contains a reference to the MouseInputSource that generated it. In an environment with a single mouse for input, all events will come from the same source, but in a multi-touch system, there may be multiple MouseInputSource objects active, each representing a stream of events coming from a particular finger.

Events coming from a single MouseInputSource are always sent in a fixed and predictable order: a mouseMove will never be called without a mouseEnter having been sent beforehand, the only events that can happen between a mouseDown and its corresponding mouseUp are mouseDrags, etc. When there are multiple touches arriving from multiple MouseInputSources, their event streams may arrive in an interleaved order, so you should use the getIndex() method to find out which finger each event came from.

See also
  MouseEvent

## Member Enumeration Documentation

## ◆ InputSourceType

enum MouseInputSource::InputSourceType

Possible mouse input sources.

Enumerator
mouse |
touch |
pen |

## Constructor & Destructor Documentation

## ◆ MouseInputSource()

MouseInputSource::MouseInputSource | ( | const MouseInputSource & |  | ) |
| noexcept

## ◆ ~MouseInputSource()

MouseInputSource::~MouseInputSource | ( |  | ) |
| noexcept

## Member Function Documentation

## ◆ operator=()

MouseInputSource & MouseInputSource::operator= | ( | const MouseInputSource & |  | ) |
| noexcept

## ◆ operator==()

bool MouseInputSource::operator== | ( | const MouseInputSource & | other | ) | const
| noexcept

## ◆ operator!=()

bool MouseInputSource::operator!= | ( | const MouseInputSource & | other | ) | const
| noexcept

## ◆ getType()

MouseInputSource::InputSourceType MouseInputSource::getType | ( |  | ) | const
| noexcept

Returns the type of input source that this object represents.

## ◆ isMouse()

bool MouseInputSource::isMouse | ( |  | ) | const
| noexcept

Returns true if this object represents a normal desk-based mouse device.

## ◆ isTouch()

bool MouseInputSource::isTouch | ( |  | ) | const
| noexcept

Returns true if this object represents a source of touch events.

## ◆ isPen()

bool MouseInputSource::isPen | ( |  | ) | const
| noexcept

Returns true if this object represents a pen device.

## ◆ canHover()

bool MouseInputSource::canHover | ( |  | ) | const
| noexcept

Returns true if this source has an on-screen pointer that can hover over items without clicking them.

## ◆ hasMouseWheel()

bool MouseInputSource::hasMouseWheel | ( |  | ) | const
| noexcept

Returns true if this source may have a scroll wheel.

## ◆ getIndex()

int MouseInputSource::getIndex | ( |  | ) | const
| noexcept

Returns this source's index in the global list of possible sources.

If the system only has a single mouse, there will only be a single MouseInputSource with an index of 0.

If the system supports multi-touch input, then the index will represent a finger number, starting from 0. When the first touch event begins, it will have finger number 0, and then if a second touch happens while the first is still down, it will have index 1, etc.

## ◆ isDragging()

bool MouseInputSource::isDragging | ( |  | ) | const
| noexcept

Returns true if this device is currently being pressed.

## ◆ getScreenPosition()

Point< float > MouseInputSource::getScreenPosition | ( |  | ) | const
| noexcept

Returns the last-known screen position of this source.

## ◆ getRawScreenPosition()

Point< float > MouseInputSource::getRawScreenPosition | ( |  | ) | const
| noexcept

Returns the last-known screen position of this source without any scaling applied.

## ◆ getCurrentModifiers()

ModifierKeys MouseInputSource::getCurrentModifiers | ( |  | ) | const
| noexcept

Returns a set of modifiers that indicate which buttons are currently held down on this device.

## ◆ getCurrentPressure()

float MouseInputSource::getCurrentPressure | ( |  | ) | const
| noexcept

Returns the device's current touch or pen pressure.

The range is 0 (soft) to 1 (hard). If the input device doesn't provide any pressure data, it may return a negative value here, or 0.0 or 1.0, depending on the platform.

## ◆ getCurrentOrientation()

float MouseInputSource::getCurrentOrientation | ( |  | ) | const
| noexcept

Returns the device's current orientation in radians.

0 indicates a touch pointer aligned with the x-axis and pointing from left to right; increasing values indicate rotation in the clockwise direction. Only reported by a touch pointer.

## ◆ getCurrentRotation()

float MouseInputSource::getCurrentRotation | ( |  | ) | const
| noexcept

Returns the device's current rotation.

Indicates the clockwise rotation, or twist, of the pointer in radians. The default is 0. Only reported by a pen pointer.

## ◆ getCurrentTilt()

float MouseInputSource::getCurrentTilt | ( | bool | tiltX | ) | const
| noexcept

Returns the angle of tilt of the pointer in a range of -1.0 to 1.0 either in the x- or y-axis.

The default is 0. If x-axis, a positive value indicates a tilt to the right and if y-axis, a positive value indicates a tilt toward the user. Only reported by a pen pointer.

## ◆ isPressureValid()

bool MouseInputSource::isPressureValid | ( |  | ) | const
| noexcept

Returns true if the current pressure value is meaningful.

## ◆ isOrientationValid()

bool MouseInputSource::isOrientationValid | ( |  | ) | const
| noexcept

Returns true if the current orientation value is meaningful.

## ◆ isRotationValid()

bool MouseInputSource::isRotationValid | ( |  | ) | const
| noexcept

Returns true if the current rotation value is meaningful.

## ◆ isTiltValid()

bool MouseInputSource::isTiltValid | ( | bool | tiltX | ) | const
| noexcept

Returns true if the current tilt value (either x- or y-axis) is meaningful.

## ◆ getComponentUnderMouse()

Component * MouseInputSource::getComponentUnderMouse | ( |  | ) | const

Returns the component that was last known to be under this pointer.

## ◆ triggerFakeMove()

void MouseInputSource::triggerFakeMove | ( |  | ) | const

Tells the device to dispatch a mouse-move or mouse-drag event.

This is asynchronous - the event will occur on the message thread.

## ◆ getNumberOfMultipleClicks()

int MouseInputSource::getNumberOfMultipleClicks | ( |  | ) | const
| noexcept

Returns the number of clicks that should be counted as belonging to the current mouse event.

So the mouse is currently down and it's the second click of a double-click, this will return 2.

## ◆ getLastMouseDownTime()

Time MouseInputSource::getLastMouseDownTime | ( |  | ) | const
| noexcept

Returns the time at which the last mouse-down occurred.

## ◆ getLastMouseDownPosition()

Point< float > MouseInputSource::getLastMouseDownPosition | ( |  | ) | const
| noexcept

Returns the screen position at which the last mouse-down occurred.

## ◆ isLongPressOrDrag()

bool MouseInputSource::isLongPressOrDrag | ( |  | ) | const
| noexcept

Returns true if this input source represents a long-press or drag interaction i.e.

it has been held down for a significant amount of time or it has been dragged more than a couple of pixels from the place it was pressed.

## ◆ hasMovedSignificantlySincePressed()

bool MouseInputSource::hasMovedSignificantlySincePressed | ( |  | ) | const
| noexcept

Returns true if this input source has been dragged more than a couple of pixels from the place it was pressed.

## ◆ hasMouseCursor()

bool MouseInputSource::hasMouseCursor | ( |  | ) | const
| noexcept

Returns true if this input source uses a visible mouse cursor.

## ◆ showMouseCursor()

void MouseInputSource::showMouseCursor | ( | const MouseCursor & | cursor | ) |

Changes the mouse cursor, (if there is one).

## ◆ hideCursor()

void MouseInputSource::hideCursor | ( |  | ) |

Hides the mouse cursor (if there is one).

## ◆ revealCursor()

void MouseInputSource::revealCursor | ( |  | ) |

Un-hides the mouse cursor if it was hidden by hideCursor().

## ◆ forceMouseCursorUpdate()

void MouseInputSource::forceMouseCursorUpdate | ( |  | ) |

Forces an update of the mouse cursor for whatever component it's currently over.

## ◆ canDoUnboundedMovement()

bool MouseInputSource::canDoUnboundedMovement | ( |  | ) | const
| noexcept

Returns true if this mouse can be moved indefinitely in any direction without running out of space.

## ◆ enableUnboundedMouseMovement()

void MouseInputSource::enableUnboundedMouseMovement | ( | bool | isEnabled,
|  | bool | keepCursorVisibleUntilOffscreen = `false`
| ) |  | const

Allows the mouse to move beyond the edges of the screen.

Calling this method when the mouse button is currently pressed will remove the cursor from the screen and allow the mouse to (seem to) move beyond the edges of the screen.

This means that the coordinates returned to mouseDrag() will be unbounded, and this can be used for things like custom slider controls or dragging objects around, where movement would be otherwise be limited by the mouse hitting the edges of the screen.

The unbounded mode is automatically turned off when the mouse button is released, or it can be turned off explicitly by calling this method again.

Parameters

  isEnabled | whether to turn this mode on or off
  keepCursorVisibleUntilOffscreen | if set to false, the cursor will immediately be hidden; if true, it will only be hidden when it is moved beyond the edge of the screen

## ◆ isUnboundedMouseMovementEnabled()

bool MouseInputSource::isUnboundedMouseMovementEnabled | ( |  | ) | const

Returns true if this source is currently in "unbounded" mode.

## ◆ setScreenPosition()

void MouseInputSource::setScreenPosition | ( | Point< float > | newPosition | ) |

Attempts to set this mouse pointer's screen position.

## Member Data Documentation

## ◆ defaultPressure

constexpr float MouseInputSource::defaultPressure = 0.0f
| staticconstexpr

A default value for pressure, which is used when a device doesn't support it, or for mouse-moves, mouse-ups, etc.

## ◆ defaultOrientation

constexpr float MouseInputSource::defaultOrientation = 0.0f
| staticconstexpr

A default value for orientation, which is used when a device doesn't support it.

## ◆ defaultRotation

constexpr float MouseInputSource::defaultRotation = 0.0f
| staticconstexpr

A default value for rotation, which is used when a device doesn't support it.

## ◆ defaultTiltX

constexpr float MouseInputSource::defaultTiltX = 0.0f
| staticconstexpr

Default values for tilt, which are used when a device doesn't support it.

## ◆ defaultTiltY

constexpr float MouseInputSource::defaultTiltY = 0.0f
| staticconstexpr

## ◆ invalidPressure

const float MouseInputSource::invalidPressure
| static

A default value for pressure, which is used when a device doesn't support it.

This is a valid value, returning true when calling isPressureValid() hence the deprecation. Use defaultPressure instead.

## ◆ invalidOrientation

const float MouseInputSource::invalidOrientation
| static

A default value for orientation, which is used when a device doesn't support it.

This is a valid value, returning true when calling isOrientationValid() hence the deprecation. Use defaultOrientation instead.

## ◆ invalidRotation

const float MouseInputSource::invalidRotation
| static

A default value for rotation, which is used when a device doesn't support it.

This is a valid value, returning true when calling isRotationValid() hence the deprecation. Use defaultRotation instead.

## ◆ invalidTiltX

const float MouseInputSource::invalidTiltX
| static

Default values for tilt, which are used when a device doesn't support it.

These are valid values, returning true when calling isTiltValid() hence the deprecation. Use defaultTiltX and defaultTiltY instead.

## ◆ invalidTiltY

const float MouseInputSource::invalidTiltY
| static

## ◆ offscreenMousePos

const Point<float> MouseInputSource::offscreenMousePos
| static

An offscreen mouse position used when triggering mouse exits where we don't want to move the cursor over an existing component.

The documentation for this class was generated from the following file:

- juce_MouseInputSource.h